
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2.Objects.GeolocationPermissionRequest
    ( 

-- * Exported types
    GeolocationPermissionRequest(..)        ,
    GeolocationPermissionRequestK           ,
    toGeolocationPermissionRequest          ,
    noGeolocationPermissionRequest          ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2.Types
import GI.WebKit2.Callbacks
import qualified GI.GObject as GObject

newtype GeolocationPermissionRequest = GeolocationPermissionRequest (ForeignPtr GeolocationPermissionRequest)
foreign import ccall "webkit_geolocation_permission_request_get_type"
    c_webkit_geolocation_permission_request_get_type :: IO GType

type instance ParentTypes GeolocationPermissionRequest = GeolocationPermissionRequestParentTypes
type GeolocationPermissionRequestParentTypes = '[GObject.Object, PermissionRequest]

instance GObject GeolocationPermissionRequest where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_geolocation_permission_request_get_type
    

class GObject o => GeolocationPermissionRequestK o
instance (GObject o, IsDescendantOf GeolocationPermissionRequest o) => GeolocationPermissionRequestK o

toGeolocationPermissionRequest :: GeolocationPermissionRequestK o => o -> IO GeolocationPermissionRequest
toGeolocationPermissionRequest = unsafeCastTo GeolocationPermissionRequest

noGeolocationPermissionRequest :: Maybe GeolocationPermissionRequest
noGeolocationPermissionRequest = Nothing

type instance AttributeList GeolocationPermissionRequest = GeolocationPermissionRequestAttributeList
type GeolocationPermissionRequestAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList GeolocationPermissionRequest = GeolocationPermissionRequestSignalList
type GeolocationPermissionRequestSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


