
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2.Objects.PolicyDecision
    ( 

-- * Exported types
    PolicyDecision(..)                      ,
    PolicyDecisionK                         ,
    toPolicyDecision                        ,
    noPolicyDecision                        ,


 -- * Methods
-- ** policyDecisionDownload
    policyDecisionDownload                  ,


-- ** policyDecisionIgnore
    policyDecisionIgnore                    ,


-- ** policyDecisionUse
    policyDecisionUse                       ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2.Types
import GI.WebKit2.Callbacks
import qualified GI.GObject as GObject

newtype PolicyDecision = PolicyDecision (ForeignPtr PolicyDecision)
foreign import ccall "webkit_policy_decision_get_type"
    c_webkit_policy_decision_get_type :: IO GType

type instance ParentTypes PolicyDecision = PolicyDecisionParentTypes
type PolicyDecisionParentTypes = '[GObject.Object]

instance GObject PolicyDecision where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_policy_decision_get_type
    

class GObject o => PolicyDecisionK o
instance (GObject o, IsDescendantOf PolicyDecision o) => PolicyDecisionK o

toPolicyDecision :: PolicyDecisionK o => o -> IO PolicyDecision
toPolicyDecision = unsafeCastTo PolicyDecision

noPolicyDecision :: Maybe PolicyDecision
noPolicyDecision = Nothing

type instance AttributeList PolicyDecision = PolicyDecisionAttributeList
type PolicyDecisionAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList PolicyDecision = PolicyDecisionSignalList
type PolicyDecisionSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method PolicyDecision::download
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PolicyDecision", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PolicyDecision", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_policy_decision_download" webkit_policy_decision_download :: 
    Ptr PolicyDecision ->                   -- _obj : TInterface "WebKit2" "PolicyDecision"
    IO ()


policyDecisionDownload ::
    (MonadIO m, PolicyDecisionK a) =>
    a ->                                    -- _obj
    m ()
policyDecisionDownload _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_policy_decision_download _obj'
    touchManagedPtr _obj
    return ()

-- method PolicyDecision::ignore
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PolicyDecision", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PolicyDecision", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_policy_decision_ignore" webkit_policy_decision_ignore :: 
    Ptr PolicyDecision ->                   -- _obj : TInterface "WebKit2" "PolicyDecision"
    IO ()


policyDecisionIgnore ::
    (MonadIO m, PolicyDecisionK a) =>
    a ->                                    -- _obj
    m ()
policyDecisionIgnore _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_policy_decision_ignore _obj'
    touchManagedPtr _obj
    return ()

-- method PolicyDecision::use
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PolicyDecision", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PolicyDecision", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_policy_decision_use" webkit_policy_decision_use :: 
    Ptr PolicyDecision ->                   -- _obj : TInterface "WebKit2" "PolicyDecision"
    IO ()


policyDecisionUse ::
    (MonadIO m, PolicyDecisionK a) =>
    a ->                                    -- _obj
    m ()
policyDecisionUse _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_policy_decision_use _obj'
    touchManagedPtr _obj
    return ()


